//Titel:            Testbeispuiel fr MDI-Fenster
//Version:          1.0
//Copyright:        HS-Harz, FB AI
//Autor:            Dipl.-Inf.(TU) Dipl.-Ing.(FH) Michael Wilhelm
//Firma:
//Beschreibung:     Einfaches Beispiel


// Beispiel fr das Observer Design Pattern
// Mit der Eingabetaste wird der Inhalt aktualisiert

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;


// InternalFrame
import javax.swing.event.*;

import java.util.Observable;
import java.util.Observer;


public class Pattern_MVC1 extends JFrame {

  // Container fr die Clientfenster
  private JDesktopPane _desktopPane = new JDesktopPane();

    // Men Variablen
  private JMenuBar menuBar1;
  private JMenu MainFile;
  private JMenuItem MnNew;
  private JMenuItem MnOpen;
  private JMenuItem MnClose;

  private JMenu MainEdit;
  private JMenuItem MnCut;
  private JMenuItem MnCopy;
  private JMenuItem MnInsert;

  private int _Fensternummer=0;


  // 4. schritt  Modell Variable deklarieren
  private CName _name;   // Modell
  private CController _controller;

   // Konstruktor
  public Pattern_MVC1() {
    this.setSize(new Dimension(800, 400));
    setGUI();
  }

  public void setGUI() {
    this.getContentPane().setLayout( new BorderLayout() );
    this.setContentPane(_desktopPane);

    setMenus();
    // Pattern_MVC
    // 5. schritt  Modell Variable erzeugen
    _name = new CName("Abba");
    //_name.setName("Paul");
    _controller = new CController();
  }



    // setzt die Mens
  private void setMenus() {
    menuBar1 = new JMenuBar();

      // DATEI
    MainFile = new JMenu("Datei");
    MnNew = new JMenuItem("Neu");
    MnClose = new JMenuItem("Schlieen");

    MnNew.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        MnNew_actionPerformed(e);
      }
    });
    MnNew.setAccelerator( KeyStroke.getKeyStroke(KeyEvent.VK_N, ActionEvent.CTRL_MASK));
    MainFile.add(MnNew);

    MainFile.addSeparator();

    // --------------------------
    MnClose.addActionListener(new ActionListener()  {

      public void actionPerformed(ActionEvent e) {
        MnClose_actionPerformed(e);
      }
    });
    MainFile.add(MnClose);


    menuBar1.add(MainFile);

    // ----------------
    this.setJMenuBar(menuBar1);

  } // setMenus


  // Men Aktions Methoden

  void MnNew_actionPerformed(ActionEvent e) {
    JInternalFrame[] ff = _desktopPane.getAllFrames();
    int n=ff.length+1;
    _Fensternummer++;

    // 6. schritt  Viewer erzeugen
    JFInternalFrame1 frame =
     new JFInternalFrame1(
    Integer.toString(_Fensternummer),
         n%3,
      _name, _controller);

    ff = _desktopPane.getAllFrames();
    int i = ff.length;
    int w = ff.length*260;
    int h = ff.length*110;
    frame.setBounds( 10, 10, 380, 50);
    frame.setLocation(  (i%2)*390+10, 60+110*(i/2)  );

    _desktopPane.add(frame, new Integer(1));
  }


  void MnClose_actionPerformed(ActionEvent e) {
    System.exit(0);
  }



  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if(e.getID() == WindowEvent.WINDOW_CLOSING) {
      System.exit(0);
    }
  }


  static public void main(String[] args) {
    try  {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
    }
    catch(Exception e) {
    }
    Pattern_MVC1 desktop = new Pattern_MVC1();
    desktop.setVisible(true);
  }

  void jTextField1_actionPerformed(ActionEvent e) {
         System.out.println("Return gedrckt");
  }



}  // Pattern_MVC1


//   |
//  +--java.util.Observable

// 2. Schritt ableiten von Observable
class CController extends
            java.util.Observable {
    // Diese Methode wird von einem Viewern aufgerufen
    //
    // 3. Schritt  Methode fr Viewer
  public void Changed(int nr) {
    System.out.println("Controller Changed");
    super.setChanged();
      // Sende Nachricht an ALLE Viewer
    super.notifyObservers( );
    //super.notifyObservers( new Integer(nr) );
  }

} // CController

// 1. Schritt ableiten von Observable
class CName  {
  String sName= "Zappa";

  public CName(String name)  {
     sName=name;
  }
  
  public String getName() {
    return sName;
  }

  public void setName(String Name) {
    this.sName = Name;
  }

} // CName



    // 6. schritt  nternalFrame
    // Implements einbauen
    // Methode Update
class JFInternalFrame1
         extends JInternalFrame
         implements Observer {
  private String _sFileName;

  private JLabel label1 = new JLabel("Student");
  private JTextField edit = new JTextField("XXXXX");

  private CName _name;
  private CController _controller;
  private String _Caption;
  int _eigeneFensternr;

  public JFInternalFrame1(
       String Caption, int nr,
       CName name, CController controller) {
    _Caption = Caption;
    setTitle(Caption);
    _eigeneFensternr=nr;

    _name = name;
    _controller = controller;
    _controller.addObserver(this);  // registrierung

    setGUI();
  }

  public void setGUI() {
    label1.setFont( new Font("Arial", Font.BOLD,28));
    edit.setText(  _name.getName()     );
    edit.setFont( new Font("Arial", Font.BOLD,28));

    this.setClosable(true);
    this.setIconifiable(true);
    this.setMaximizable(true);
    this.setResizable(true);
    this.getContentPane().setLayout( new GridLayout(1,2) );


    this.getContentPane().add(label1);
    this.getContentPane().add(edit);

    edit.addActionListener(new java.awt.event.ActionListener() {
        //  Aufgerufen wenn Return-Taste
      public void actionPerformed(ActionEvent e) {
        edit_Change(e);
      }
    });


  }  // setGUI


    // 7. schritt  Update-Methode
    //   aufgerufen vom Controller !
  public void update(Observable o,
                 Object arg) {
    System.out.println("Update");
    Integer I = (Integer) arg;
//    if ( ( I.intValue()==_eigeneFensternr)
//          || ( I.intValue()==0) ){
      System.out.println("ich bin gemeint: "+_Caption);
      edit.setText( _name.getName() );
      edit.updateUI();
  //  }
  }

    // 8. schritt  aufgerufen von der Return-Taste
  void edit_Change(ActionEvent e) {
    System.out.println("gendert");
    _name.setName( edit.getText() );
    //. .DataChangedFromViewer( nr, new String(  ) );
    _controller.Changed(_eigeneFensternr);
    //.DataChangedFromViewer( nr, new String(edit.getText()  ) );
  }



}  // JFInternalFrame1


