//Titel:            MVC Pattern mit Testbeispiel fr MDI-Fenster
//Version:          1.0
//Copyright:        HS-Harz, FB AI
//Autor:            Dipl.-Inf.(TU) Dipl.-Ing.(FH) Michael Wilhelm//Firma:
//Beschreibung:     Einfaches Beispiel


// hier ein einfaches Datenmodell

// in Beispiel Pattern_MVC3 wird ein Singleton Pattern verwendet


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;


// InternalFrame
import javax.swing.event.*;

import java.util.Observable;
import java.util.Observer;
import java.beans.*;

// plaindocument
import javax.swing.text.PlainDocument;
import javax.swing.text.AttributeSet;
import javax.swing.text.BadLocationException;




public class Pattern_MVC3 extends JFrame {

  // Container fr die Clientfenster
  private JDesktopPane _desktopPane = new JDesktopPane();

  private int _tag=0;

    // Men Variablen
  private JMenuBar menuBar1;
  private JMenu MainFile;
  private JMenuItem MnNew;
  private JMenuItem MnOpen;
  private JMenuItem MnClose;

  private JMenu MainEdit;
  private JMenuItem MnCut;
  private JMenuItem MnCopy;
  private JMenuItem MnInsert;


  private CName name;

   // Konstruktor
  public Pattern_MVC3() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    this.setSize(new Dimension(800, 600));
    setGUI();
  }

  public void setGUI() {
    this.getContentPane().setLayout( new BorderLayout() );
    this.setContentPane(_desktopPane);

    setMenus();
    // Pattern_MVC
    name = new CName();
    name.setName("Paul");
  }   // setPaul



    // setzt die Mens
  private void setMenus() {
    menuBar1 = new JMenuBar();

      // DATEI
    MainFile = new JMenu("Datei");
    MnNew = new JMenuItem("Neu");
    MnClose = new JMenuItem("Schlieen");

    MnNew.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        MnNew_actionPerformed(e);
      }
    });
    MnNew.setAccelerator( KeyStroke.getKeyStroke(KeyEvent.VK_N, ActionEvent.CTRL_MASK));
    MainFile.add(MnNew);

    MainFile.addSeparator();

    // --------------------------
    MnClose.addActionListener(new ActionListener()  {

      public void actionPerformed(ActionEvent e) {
        MnClose_actionPerformed(e);
      }
    });
    MainFile.add(MnClose);


    menuBar1.add(MainFile);

    // ----------------
    this.setJMenuBar(menuBar1);

  } // setMenus


  // Men Aktions Methoden

  void MnNew_actionPerformed(ActionEvent e) {
    _tag++;
    JFInternalFrame1 frame =
       new JFInternalFrame1(_tag, null, name);
    JInternalFrame[] ff = _desktopPane.getAllFrames();
    int i = ff.length;
    int w = ff.length*260;
    int h = ff.length*110;
    frame.setBounds( 10, 10, 350, 50);
    frame.setLocation(  (i%2)*360+20, 60+130*(i/2)  );

    _desktopPane.add(frame, new Integer(1));
  }


  void MnClose_actionPerformed(ActionEvent e) {
    System.exit(0);
  }



  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if(e.getID() == WindowEvent.WINDOW_CLOSING) {
      System.exit(0);
    }
  }


  static public void main(String[] args) {
    try  {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
    }
    catch(Exception e) {
    }
    Pattern_MVC3 frame = new Pattern_MVC3();
    frame.setVisible(true);
  }

  void jTextField1_actionPerformed(ActionEvent e) {
         System.out.println("Return gedrckt");
  }



}  // Pattern_MVC3


//   |
//  +--java.util.Observable

// ------------------------------------------------------------
// ------------------------------------------------------------
// ------------------------------------------------------------
// ------------------------------------------------------------
// Datenmodell:   Modell plus Controller
class CName  extends java.util.Observable {
  String sName= "Freya";
  boolean _bUpdateModus=false;

  /*public void notifyObersers(Object b) {
    setChanged();
    super.notifyObservers( this );
  }
  */

  public void setUpdateModus(boolean bUpdateModus) {
    _bUpdateModus = bUpdateModus;
  }
  public boolean getUpdateModus() {
    return _bUpdateModus;
  }

  public String getName() {
    return sName;
  }

  public void setName(String Name) {
    this.sName = Name;
  }

  public void Update(String s) {
    System.out.println("s in CName: "+s);
    if ( ! getUpdateModus() ) {
      setUpdateModus(true);
      this.setName(s);
      setChanged();
      super.notifyObservers();
    }
    else {
      System.out.println("s in CName: getUpdateModus() = true");
    }
  }

} // StudentenName



// ---------------------------------

interface TextField_Change {

  public void sendChangeMessage();

}
       

class JFInternalFrame1 extends JInternalFrame
            implements Observer, TextField_Change {
  private String _sFileName;
  private String _Caption;

  private int _tag;

  private JLabel label1 = new JLabel("Student");
  private gTextField edit =
         new gTextField("XXXXX");

  private CName DatenModell;

  public void sendChangeMessage() {
    if ( DatenModell.getUpdateModus() ) {
      System.out.println(" JFInternalFrame1 sendChangeMessage = true");
    }
    else {
      System.out.println(" JFInternalFrame1 sendChangeMessage = true");
      DatenModell.Update( new String(edit.getText()  ) );
      DatenModell.setUpdateModus(false);
    }
  }

  public JFInternalFrame1(int tag, String sFileName, Observable DatenModell) {
    _tag = tag;
    _sFileName = sFileName;
    this.DatenModell = (CName) DatenModell;  //
    if (sFileName==null)
      _Caption = "noname";
    else
      _Caption = sFileName;
    setGUI();
  }

  void setGUI() {
    DatenModell.addObserver(this);  // registrierung

    CName name = (CName) DatenModell;
    edit.setText(    name.getName()     );
    edit.setFont( new Font("Arial", Font.BOLD,28));
    label1.setFont( new Font("Arial", Font.BOLD,28));

    edit.setDocument( new gTextDocument(this) );


    this.setClosable(true);
    this.setIconifiable(true);
    this.setMaximizable(true);
    this.setResizable(true);
    this.getContentPane().setLayout( new GridLayout(1,2) );
    this.setTitle(_Caption);

    this.getContentPane().add(label1);
    this.getContentPane().add(edit);

    edit.addActionListener(new java.awt.event.ActionListener() {
        //  Aufgerufen wenn Return-Taste
      public void actionPerformed(ActionEvent e) {
        edit_Change(e);
      }
    });


  }  // jbInit

    // Weiterleitung abschalten
  public void update(Observable o, Object arg) {
    System.out.println("Update");
    edit.setText( DatenModell.getName() );
  }


  void edit_Change(ActionEvent e) {
    System.out.println("gendert");
    DatenModell.Update( new String(edit.getText()  ) );
  }



}  // JFInternalFrame1



class gTextDocument extends PlainDocument {
    static int s_offs;
    static String s_str;
//    static AttributeSet s_a;
    static int s_len;
    static int Befehl = 0;

    TextField_Change _parent;

    private gTextDocument() {
     _parent = null;
    }

      // neuer Konstruktor
    public gTextDocument( TextField_Change parent ) {
     _parent = parent;
    }

    public void insertString(
    int offs, String str,
    AttributeSet a) throws BadLocationException {
        if (str == null) {
            return;
        }
        String s = super.getText(0,  super.getLength() );
        System.out.println("Insert Text: "+s );
        Befehl = 1;
        s_offs = offs;
        s_str = str;
        // s_a = a;
        super.insertString(offs, str, a);
          // View wird benachrichtigt
        _parent.sendChangeMessage();
    }

    public void remove(int offs, int len) throws BadLocationException {
        if (len == 0) return;
        Befehl = 2;
        s_offs = offs;
        s_len = len;
        super.remove(offs, len);
        String s = super.getText(0,  super.getLength() );
        System.out.println("Remove Text: "+s );
          // View wird benachrichtigt
        _parent.sendChangeMessage();
    }
}


class gTextField extends JTextField
        implements DocumentListener {

   public gTextField() {
     super();
   }

   public gTextField(String text) {
     super(text);
   }

    public void insertUpdate(DocumentEvent e) {
        // if (getUpdateModus()) return;
             // Debug.print("GUI", Debug.INFO, " insertUpdate "+e.getType().toString() );
        // change();
        System.out.println("insert");
    }



    public void removeUpdate(DocumentEvent e) {
        //if (getUpdateModus()) return;
        // change();
        System.out.println("remove");
    }

    public void changedUpdate(DocumentEvent e) {
        // if (getUpdateModus()) return;
        // change();
        System.out.println("Change Update");
    }


}


